#!/usr/bin/perl

#
# dhcpadmin
#
# Copyright (C) 2008 DesigNET, INC.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

##########################################################
#
# ֥ͥå
#
# $RCSfile: subnetlist.cgi,v $
# $Revision: 1.20 $
# $Date: 2013/01/13 02:25:56 $
#
##########################################################

# 饤֥ɲ
use lib "../lib";

use strict;
use CGI;
use Net::IPv4Addr qw( :all );

# 饤֥ɤ߹
require "libcommon.pl";
require "libpage.pl";
require "libpost.pl";
require "libhost.pl";
require "librange.pl"; 
require "subnetlist.pl"; 


##########################################################
# ڡѥå
##########################################################
package mypage;

my $bodyhtml;

use vars qw(@ISA);

#
# pageλҥ饹
#
@ISA = qw(page);
sub new
{
    bless {};
}

#
# ɽ
#
sub display_body
{
    print $bodyhtml;
}

##########################################################
# ᥤѥå
##########################################################
package main;

##########################################################
# 
##########################################################

my $q = new CGI;
my %conf;
my $msg;
my @errmsg;
my $linkflag = 1; 
my $ref = $q->param('REF');

# 
my $LOCATIONADD = "subnetadd.cgi";
my $LOCATIONRANGE = "range.cgi";

# 
if (dhcp_init(\%conf, $linkflag, $ref, \@errmsg) != 0) {
    syserr($errmsg[$main::L_DISP]);
    errlog($errmsg[$main::L_LOG], $conf{'facility'});
    exit 1;
}

##########################################################
# ᥤ
##########################################################

my $postdata = "REF=" . $ENV{SCRIPT_NAME};  # ե顼ǡǼ
my %serverlist;
my $mainflg;
my $subnetdir;
my $subnetlist = $q->param('subnetlist');
my $subnethtml;
my $texthtml;
my @selectsubnet = ($subnetlist);
my %chgdata;
my $subnet = $q->param('subnet');
my $netmask = $q->param('netmask');
my $postresult;
my $location;
my $dispsubnet;
my @value;


# å
$errmsg[$main::L_DISP] = $main::LANG{$ENV{$main::DISPLANG}}{'INFO_SUBNETLIST'};
if (defined($q->param('dispmsg')) == 1) {
    $errmsg[$main::L_DISP] = $q->param('dispmsg');
}

# ͤκƸ
if (defined($q->param('addsubnet')) == 1) {
    $subnet = $q->param('addsubnet');
}
if (defined($q->param('addnetmask')) == 1) {
    $netmask = $q->param('addnetmask');
}

# ܥ󲡲
if ($q->param('del') eq "del") {

    # /ʬ
    @value = split(/\//, $subnetlist);

    # ɽ
    $dispsubnet = $value[1] . "/" . $value[2];

    # ֥ͥåȥǥ쥯ȥ
    $subnetlist = $value[1] . "-" . $value[2];
    $subnetdir = $main::WORKDIR . "/" . $value[0] . "/" . $subnetlist;
 
    # ֥ͥåȤΥǥ쥯ȥ۲hostե뤬뤫ǧ
    if (main::check_hostsize($subnetlist, $value[0]) == 1) {
        $errmsg[$main::L_DISP] = $main::LANG{$ENV{$main::DISPLANG}}{'ERR_SUBNET_DATA6'};
        $errmsg[$main::L_LOG] = $main::LANG{$ENV{$main::DISPLANG}}{'ERR_SUBNET_DATA6'};
    } else {   

        if (-d $subnetdir) {
            # ֥ͥåȤΥǥ쥯ȥ
            if (main::del_onedir($subnetdir, \@errmsg) == -1) {
                syserr($errmsg[$main::L_DISP]);
                errlog($errmsg[$main::L_LOG], $conf{'facility'});
                exit 1;
            }
        }

        # å
        $errmsg[$main::L_DISP] = $main::LANG{$ENV{$main::DISPLANG}}{'INFO_SUBNET_DATA'} . "(" . $dispsubnet . ")";
        $errmsg[$main::L_LOG] = $main::LANG{$ENV{$main::DISPLANG}}{'INFO_SUBNET_DATA'} . "(" . $dispsubnet . ")";
    }
    errlog($errmsg[$main::L_LOG], $conf{'facility'});
}

# ɲåܥ󲡲
if (defined($q->param('add')) == 1) {

    # ֥ͥå/ͥåȥޥå
    if (check_networkform($subnet, $netmask, \@errmsg) == 0) {
            
        # ݥȥǡȤΩ
        $postdata .= "&subnetlist=" . $subnetlist . 
                     "&status=subnetadd" . "&subnet=" . $subnet . "&netmask=" .
                     $netmask;

        # ǡΥݥ
        if (location_display($LOCATIONADD, $postdata, \@errmsg) == -1) {
            syserr($errmsg[$main::L_DISP]);
            errlog($errmsg[$main::L_LOG], $conf{'facility'});
            exit 1;
        }
    }
    # 쥯ȤκƸ
    push(@selectsubnet, $subnetlist);
    
}

# ɽ
if (make_subnethtml(\$subnethtml, \@selectsubnet, \@errmsg) != 0) {
    syserr($errmsg[$main::L_DISP]);
    errlog($errmsg[$main::L_LOG], $conf{'facility'});
    exit 1;
}



##########################################################
# ƥץ졼֤
##########################################################

my $id = "subnetlist"; 	# ɽѥڡID


# ִǡϿ
$chgdata{'SUBNETLIST'} = $subnethtml;
$chgdata{'SUBNET'} = $q->escapeHTML($subnet);
$chgdata{'NETMASK'} = $q->escapeHTML($netmask);

# ƥץ졼֤
if (page::replace_template($id, \$bodyhtml, \%chgdata, \@errmsg) != 0) {
    syserr($errmsg[$main::L_DISP]);
    errlog($errmsg[$main::L_LOG], $conf{'facility'});
    exit 1;
}

##########################################################
# ڡɽ
##########################################################

my $tabId = "nw";
my $obj;
my $sys_err = 0;

$obj = new mypage;

# ɽʸ<br>ؤѴ
main::conv_br(\$errmsg[$main::L_DISP]);

if ($obj->display($id, \$sys_err, $tabId, \@errmsg) == -1) {
    syserr($errmsg[$main::L_DISP]);
    errlog($errmsg[$main::L_LOG], $conf{'facility'});
    exit 1;
}

exit 0;
